// zombie.c
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/wait.h>

void sigalarm_handler(int sig) {
  printf("BEEP, signal %d caught\n", sig);
  fflush(stdout);
}

void main()
{ 
  int i = 0, stat;
  pid_t pid, child;

  if (signal(SIGCHLD, sigalarm_handler) == SIG_ERR) {
    printf("Error call to signal, SIGCHLD\n");
    exit(1);
  }

  pid = fork();
  if (pid == 0) {   // CHILD
    printf("child [z] `runs' for 15 secs...\n");
    sleep(15);
    char *argv[2] = {"slp", NULL};
    printf("child [z] changes to [slp] and runs 20 secs...\n");
    execve("./slp", argv, NULL); // slp child sleeps for 20 seconds
  }
  else {            // PARENT no wait
    while (++i < 55) {
      printf("parent is alive, but not waiting (%d)...\n", i);
      sleep(1);
    }
    child = waitpid(pid, &stat, 0);
    printf("parent waitpid() to reap the child...\n");
    printf("child [%d] terminates with status (%d)\n",
           child, WEXITSTATUS(stat));
    while (++i < 65) {
      printf("parent is alive (%d)...\n", i);
      sleep(1);
    }
  }
}
